// jsForm generator ************************
// formgen 0.3.0 19 March 2024
// free to use but no warranties
// El Condor - Condor Informatique - Turin
// *****************************************
if (typeof(window.$) != "function") var $ = function (id) {return document.getElementById(id);};  // wrap getElementById
class fGen {
constructor(idDiv,param) {
	this.formGen(idDiv,param)
}
fg_dictionary = {};
listGroups = {};		// Lists and combos group key: fieldName + itemValue value: group
genImgTag(txt) {
	var rTxt = txt;
	var aTxt = fGen.prototype.fg_extractTokens(txt);
	for (let i = 0;i<aTxt.length;i++) {
		if (fGen.prototype.isGraphicFile(aTxt[i])) rTxt = rTxt.replace(aTxt[i],"<img src='"+aTxt[i]+"'>")
		else rTxt = rTxt.replace(aTxt[i],fGen.prototype.translate(this.fg_dictionary,aTxt[i]))
	}
	return (rTxt == txt) ? fGen.prototype.translate(this.fg_dictionary,txt): rTxt
	return rTxt
}
createOptions(id,listItems) {	// lists and combos
	const aItems = fGen.prototype.splitKeyValue(listItems);	// clean list
	var opt = ""
	var group = "";
	aItems.forEach(aItem => {		
		if (aItem[0] == "") {
			opt += "<optgroup label='"+aItem[1]+"'>"
			group = aItem[1];
		} else {
			opt += "<option Value='" + aItem[0].replace(/'/g,"&#39;") + "'>" + this.translate(this.fg_dictionary,aItem[1]) + "</option>"
			this.listGroups[id+aItem[0]] = group;
		}
	})
	if ($(id) == null) return opt;	// when invoked in form building
	var x = $(id);
	if ($(id).type == "text") x = $(id+"_List");	// is LIST type	
	x.innerHTML = opt;
	x.selectedIndex = -1
}
fg_link(frm,field,link,type) {	// type -1 -> Group, 0 -> key, 1 -> Exposed
	if (frm[link] != undefined) {
		var value = frm[field].value
		if (type != 0) value = type > 0 ? frm[field].options[frm[field].options.selectedIndex].text : this.listGroups[frm.id + field + value]
		if (frm[link].type != "textarea") {
			frm[link].value = value
		} else frm[link].value += ((frm[link].value != "")?"\n":"") + value
	}
}
splitKeyValue(itms) {	// return array of items
	var aRet = new Array();
	const aSplit = itms.split(/,\s*/)
	for (var i in aSplit) {
		if (i == 0 || !/^\s*$/.test(aSplit[i])) {    // not empty (except the first one)
			var a = aSplit[i].split(/[:=]/);
			a[a.length-1] = a[a.length-1]
			aRet[aRet.length] = [a[0],(a.length > 1) ? a[1]:a[0]];
		}
	}
	return aRet;
}
formGen (idDiv,param) {
/* ************************* some functions *********************** */
	var check = function(frm,widget) {	// can control all form or only the widget
		if (widget == undefined) var widget = "";
		var aErrors = [];
		for (var field in controls) {
			var aItems = controls[field];
			if (field == "*") {		// general check
				var checkAnswer = window[aItems[0][1]](frm);
				if (checkAnswer != "") aErrors[aErrors.length] = checkAnswer;
				continue
			}	
			if (widget != "" && widget.name != field) continue;
			var widgetValue = (widget == "") ? frm[field].value : widget.value;
			if (frm[field].style != undefined) frm[field].style.borderColor = "gray";
			var cfrOperands = {"<=":2,"<":2,">=":1,">":1,"==":3}
			for (k=0;k<aItems.length;k++) {
				var err = false;	// if error is red
				var operator = aItems[k][0].toLowerCase()
				switch (operator) {
					case "is":
						if (aItems[k][1].toLowerCase() == "mail") {
							err = (widgetValue != "" && !/^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/.test(widgetValue));
						} else if ((aItems[k][1]).toLowerCase() == "required") {
							err = (/^\s*$/.test(widgetValue));
						} else {	// my be a regular expression
							var regExpr = new RegExp(aItems[k][1]);
							err = (widgetValue != "" && !regExpr.test(widgetValue));
						}
						break;
					case "function":
						err = (!window[aItems[k][1]](frm,field,widgetValue));
						break;
					case "==": case "!=": case ">": case ">=": case "<": case "<=":
						if (frm[field].type == "number") {
							err = !eval("Number(widgetValue) "+operator+" Number(aItems[k][1])")
						} else {
							err = !eval("widgetValue "+operator+" aItems[k][1]")
						}
						break;
				}
				if (err) {
					aErrors[aErrors.length] = field+": "+aItems[k][2];
					if (frm[field].style != undefined) frm[field].style.borderColor = "red";
				}
			}
		}
		return aErrors;
	};
	var storeDefaults = function(item) {	// used for store defaults
		if (!Array.isArray(item)) item = fGen.prototype.fg_extractTokens(item);
		for (var j=0;j<item.length; j++) {
			const [name,value] = item[j].replace(/\s*[:=]\s*/,"0x00").split("0x00");
			if (value != undefined) {
				if (widgets[name] == undefined) console.log(name + " isn't a field")
				else widgets[name].default = value;
			};
		}
	}
	var fg_setEvent = function (name,evnt,parameters) {
		var aItems = (widgets[name][0] == "R") ? fGen.prototype.splitKeyValue(widgets[name][3]) : [[""]];
		for (var k=0;k<aItems.length;k++) {
			if (events[name+aItems[k][0]] == undefined) events[name+aItems[k][0]] = {}
			events[name+aItems[k][0]][evnt.toLowerCase()] = parameters
		}
	}
	var fg_handle = function (frm,button) {	// send request
		const jsForm = frm.fg_jsForm;
		if (button == "fg_Cancel") {
			frm.innerHTML = "<input type=hidden name='fg_Button' value='fg_Cancel'>"
		} else {
			frm.fg_Button.value = button;
			frm.fg_formFields(frm,true);	// for bind the this
			var aErrors = check(frm);		// data control ******************
			if (aErrors.length > 0)	return alert("Errors:\n"+aErrors.join("\n"));
		}
		if (jsForm.server != "" && jsForm.call == "") {				// only URI
			if (button != "fg_Cancel") {
				if (jsForm.encoding != undefined) frm.encoding = "multipart/form-data";	// for files
				frm.action = jsForm.server;
				frm.target = jsForm.target;
				frm.submit();
			}
		} else if (jsForm.server == "" && jsForm.call != "") {		// only call function
			window[jsForm.call](frm);
		} else if (jsForm.server != "" && jsForm.call != "") {		// call Ajax receive in function
			if (jsForm.encoding != undefined) frm.encoding = "multipart/form-data";	// for files
			fGen.prototype.ajax(jsForm.server,frm,window[jsForm.call]);
			
		} else {													// no uri no function
			if(button != "fg_Cancel" && jsForm.static == 0) $(idDiv).innerHTML = fGen.prototype.showData(getData(frm));
		}
		if (jsForm.static == 0) {
			intervalHandlers.map(h => {clearInterval(h)});
			frm.innerHTML = ""
		} else {
			if(button != "fg_Cancel" && jsForm.static > 1) {
				setTimeout(function(){fGen.prototype.setDefaults(frm.id)},100);		// 1 static, 2 reset form
			}
		}
	}
	var fg_handleEnter = function (frm,field,parm) {	// for capture enter key
		if (event.key == "Enter") {
			var aErrors = check(frm);		// data control ******************
			event.preventDefault();
			if (aErrors.length > 0)	alert("Errors:\n"+aErrors.join("\n"));
			else fg_handle(frm,event.target.name);
		}
	}
	var fg_handleInput = function (frm,field) {	// for check numeric
		if (fg_handleInput.re == undefined) fg_handleInput.re = {positive:/[^\d]/,integer:/[^-\d]/,float:/[^-.\d]/}
		var v = frm[field].value
		var key = event.key
		var widget = widgets[field]
		if (fg_handleInput.re[widget.type].test(key)) frm[field].value = v.replace(key,"")
		else {
			var caret = event.target.selectionStart
			if (widget.type == "float" && key == "." && v.match(/\./g).length > 1) 
					frm[field].value = v.substring(0,caret-1) + v.substring(caret)
			if (widget.type != "positive" && key == '-') {
				frm[field].value = v.substring(0,caret-1) + v.substring(caret)
				if ((frm[field].value.match(/-/) || []).length == 0) frm[field].value = "-"+frm[field].value
			}
		}			
	}
	var createButton = function(f) {
		var [type,name,caption,...extra] = f
		var b = `\n<button type='button' name='${name}' id='${jsForm.name + name}' ${(has(extra,"title")) ? " title='" + getParms(extra,"title","") + "'" : ""}`
		b += has(extra,"width") ? " style='width:"+getParms(extra,"width")+"px'" : ""
		if (name == "fg_Reset") b+= " onclick='fGen.prototype.setDefaults(this.form.id)'"
		else {
			if (events[name] == undefined || events[name].click == undefined) fg_setEvent(name,"click",{call:fg_handle,field:name})			
		}
		b += (imgFile.test(caption) 	// is graphic file?
			? " class='fg_GButton'><img src='" + caption + "' class='fg_GButton'>"
			:  " class='fg_Button'>"+caption)
		if (f.inline != undefined) {b = b+f.inline;}
		b += "</button>";
		return b
	};
	const contains = (h,parm) => {
		const re = new RegExp("^"+parm+"\\s*[:=]|^"+parm+"$","i");
		return h.findIndex(el => re.test(el))
	};
	var getParms = function(h,parm,def) {
		const indx = contains(h,parm)
		if (indx == -1) return def != undefined ? def : ""
		var a = h[indx].replace(/\s*[:=]\s*/,"0x00").split("0x00")
		if (a.length > 1) return a[1];
		return indx < h.length-1 ? h[indx+1] : (def != undefined ? def : "")
	}
	var getParmsKey = function(h,parm,def) {
		const indx = contains(h,parm);
		if (indx == -1) return def != undefined ? def : ""
		return h[indx].split(/\s*[:=]\s*/,1).toString().toLowerCase()
	}
	var has = (h, parm) => contains(h,parm) > -1 ? true:false
	var log10 = val => Math.log(val) / Math.LN10;
	var normalizeLabel = l => {
		l = l.replace(/(_[a-zA-Z])/, x => " " +x.substr(1,1).toLowerCase())			// aaa_bbb 
		l = l.replace(/([a-z])([A-Z])/, (mtch,p1,p2) => p1+" " +p2.toLowerCase())	// aaaBbb
		return l.substr(0,1).toUpperCase() + l.substr(1)
	}	
	var saveDefault = function(c,frmID,name) {	// for combo, list and defaults
		if (name.endsWith('*')) {storeDefaults(c,defaults)}	// this is the default list 
		else if (!(widgets[name][0] == "CMB" || widgets[name][0] == "L") || c.split(/,\s*/).length == 1) widgets[name].default = c
	}
	var setValue = function(fld,value) {
		var type = widgets[fld][0];
		var id = jsForm.name+fld;	// the name of control
		if (type == "S") {
			if (value != "") $(id).value = value;
			$("s_"+id).innerHTML =  value;	// $(id).value;
		} else if (type == "DATE") {
			if (value.toLowerCase() == "today") {
				$(id).value = new Date().toISOString().slice(0,10)
			} else $(id).value = value
		} else if (type == "B") {
			if (value != undefined && value.toLowerCase() == "off") $(id).disabled = true;
		} else if (type == "R") {
			$(id+value).checked = true;
		} else if (type == "CKL") {
			$(jsForm.name+value).checked = true;
		} else if (type == "CMB") {
			if (value == "") $(id).selectedIndex = -1
			else {
				$(id).value = value;
				const index = $(id).options.selectedIndex
				if (index != -1) $(id).form[fld+"_Exposed"].value = $(id).options[index].text	// my be value isn't in combo
				else console.log("Default value",value,"for",fld,"not in list") 
			}
		} else if (type == "I") {
			if (value != "") fGen.prototype.showImage(id,value);
		} else if (type == "C") {
			$(id).innerHTML = value.replace("\n","<br>")
		} else {
			if ($(id) != null) {$(id).value = value;}	// Typically text, check box and list fields
		}
	}
	var getData = (frm) => formFields(frm,true)
	var formFields = function(frm,ret) {	// ret = true sets names of modified fields
		if (ret == undefined) var ret = false;
		if (typeof frm == "string") frm = $(frm)
		var f = {};
		for (i = 0; i < frm.length; i++) {
			name = frm.elements[i].name.replace("[]","");
			const fieldID = $(frm.elements[i].id)
			type = (widgets[name] != undefined) ? widgets[name][0] : ""
			switch (frm.elements[i].type) {
				case "checkbox":
					f[name] = (frm.elements[i].checked)?frm.elements[i].value:"";
					break;
				case "button":
					f[name] = (frm.elements[i].disabled)?"off":frm.elements[i].value;
					break;
				case "radio":
					if (frm.elements[i].checked) f[name] = frm.elements[i].value;
					break;
				case "hidden":
					f[name] = frm.elements[i].value
					break;
				case "select-multiple":
					var fld = frm.elements[i];
					var v = [];
					for (var j = 0; j < frm.elements[i].options.length; j++) {
					  if (fld.options[j].selected) v.push(fld.options[j].value);
					}
					f[name] = v
					break
				default:
					if (ret && widgets[name].disabled) frm.elements[i].disabled = false // hope is text
					if (!ret && widgets[name].disabled) frm.elements[i].disabled = true // and textarea disabled
					f[name] = frm.elements[i].value
			}
			if (type == "CMB") {
				f[name+"_Group"] = this.listGroups[frm.id + name + fieldID.value]
				if (fieldID.options.selectedIndex >= 0) f[name+"_Exposed"] = fieldID.options[fieldID.options.selectedIndex].text
				frm[name+"_Group"].value = f[name+"_Group"]
				frm[name+"_Exposed"].value = f[name+"_Exposed"]
			} else if (type == "CKL") {
				f[name] = 0
				fGen.prototype.splitKeyValue(widgets[name][3]).forEach(item => {if (frm[item[0]].checked) f[name] += 1});
				frm[name].value = f[name]
			}
		}
		if (ret) {
			var v = []
			for (const name in formFields["fg_"+frm.id]) {
				if (!name.startsWith("fg_") && formFields["fg_"+frm.id][name] != f[name]) v.push(name);
			}
			frm.fg_Changed.value = v.join();
			f.fg_Changed = frm.fg_Changed.value
			frm.fg_TimeStamp.value = fGen.prototype.timeStamp(new Date());
			f.fg_TimeStamp = frm.fg_TimeStamp.value;
			return f
		} else {formFields["fg_"+frm.id] = f}
	}
	var idNameSize = function (wdg) {		// prepare input field
		var ctrl = "id='"+jsForm.name+wdg[1] + "' name='"+wdg[1] + "'";
		ctrl += " size='" + +wdg.width + "'"
		if (wdg.hint != "") {
			ctrl += ((wdg.width < wdg.hint.length) ? " title='":" placeholder='") + wdg.hint + "'"; // hint or title }
		}
		return ctrl;
	};
	var hasGraphicFile = f => /(.*(:|\t)?).+(\.png|\.gif|\.jpeg|\.jpg|\.gif|\.ico)(:|\t|$)/i.test(f) 
/* ************************* end some functions *************************/
	if (idDiv.trim() == "") idDiv = "fg_PopUp";
	if(!$(idDiv)) {	// if div is not present is create as PopUp
		var link = document.body.appendChild(document.createElement('DIV'));
		link.setAttribute('id', idDiv);
		link.className = 'fg_PopUp';
	}
	if (param == undefined) var param = $(idDiv).innerHTML;
	if (param == "") param = "C '' Nodata!";
	var aLists = {};			// Lists and combos array
	var aGets = new(Array);		// GETs array
//	var store = idDiv;			// must be here for output ID
	var widgets = {};			// widgets array and properties
	var events = {};			// key name event = [function, param,...]
	var afterFields = {};		// key fieldName = [Type: , Value:]	
	var hiddens = {fg_Button:"",fg_Changed:"",fg_TimeStamp:""} // Hiddens data
	var jsForm = {formID:"fg_Form",title:"",static:0,server:"",call:"",name:"",target:"_blank"} // Form data
	var llText = 50;			// limit from text and textarea
	var controls = {}			// controls
	var defaults = [];			// defaults
	var erasables = {}			// object of name : ID
	var intervalHandlers = new Array();	// setInterval handlers
	const imgFile = new RegExp('(.gif|.jpg|.ico|.png)$', 'i');
	var eventOnStart = ""
	var typeOfButton = false;		// 1 if alternative Ok button(s), 2 standard buttons
	const styles = `
<style type='text/css'>
.fg_Title img,.fg_Comment img,.fg_Label img,.fg_Inline img,fg_Button img {
	padding: 0 5px;
	vertical-align:middle;
}
.fg_Erase {cursor:pointer;color:#888;padding:0 4px}
.fg_Number {text-align:right}
.fg_PopUp {cursor:move}
.fg_slider {width:3em;padding:0 5px}
</style>
`
	var convertType = {TEXT: "T", LIST: "L", SLIDER:"S",RDB:"R",IMG:"I",IMAGE:"I",
				COMMENT: "C",CONTROL: "CHECK",REQUIRED:"REQ",HIDDEN:"H",DEFAULTS:"DEFAULT",DICTIONARY:"DICT"}
	var btnTypes = {B:"",GB:"",IB:""}	// buttons type
	var okTypes = {T:2,CKB:3,CMB:2,L:1.5,S:3,R:2,DATE:2,CKL:3}	// to establish the buttons to display
	var lengths = {S:150,T:20,C:0,L:0,CMB:0,R:0}	// if no length is provided is 20 characters for texts
	var numberLength = {integer:10,float:11,positive:9}
	var acceptedTypes = {B:"",C:"fg_Comment",CKB:"",CKL:"",CMB:"",I:"",L:"",R:"",S:"",H:"",DATE:"",T:""}
// ******************************* start build *************************
	var wdg = param.split(/\r\n|\r|\n/)		// all line separators Windows, MacOS, Unix
	var i,j,k;
	var lone = 0;		// 0 no widget, 2 only one CMB or Radio, > 2 some widgets
	var loneField = ""
	for (i=0;i<wdg.length; i++) {
		if (/^\s*$|^\/\/.*/.test(wdg[i])) continue	// empty or comment
		var field = fGen.prototype.fg_extractTokens(wdg[i])
		while (field.length < 4) {field.push("")}
		field[0] = field[0].toUpperCase();			// upper-case control name
		if (convertType[field[0]] != undefined) {field[0]  = convertType[field[0]]}
		type = field[0]
		if (acceptedTypes[type] != undefined) {
			if (field[1] == "") field[1] = "fg_" + i;	// generated name
			[,name,label,...extra] = field;
			widgets[name] = []
			widgets[name].width = getParms(extra,"width",((lengths[type]) == undefined) ? 20 : lengths[field[0]])
			widgets[name].default = this.translate(this.fg_dictionary,getParms(extra,"value|default"))
			widgets[name].place = getParmsKey(extra,"after|below")
			widgets[name].placeField = getParms(extra,"after|below","")
			if (has(extra,"title")) widgets[name].title = getParms(extra,'title')
			if (has(extra,"class")) widgets[name].class = getParms(extra,'class')
			if (type == "B") {
				if(!has(extra,"inline|after|below")) typeOfButton =  typeOfButton | (/fg_Cancel|fg_Reset|fg_Ok/.test(name) ? 2 : 1)
				else widgets[name].inline = fGen.prototype.translate(this.fg_dictionary,getParms(extra,"inline"))
			} 
		}
		if (type == "FORM") {
			jsForm.name = field[1]
			jsForm.title = field[2]
			jsForm.server = getParms(field.slice(2),"server")
			jsForm.call = getParms(field.slice(2),"call")
			jsForm.target = getParms(field.slice(2),"target","_blank")
			if (has(field.slice(2),"static")) jsForm.static = 1
			if (has(field.slice(2),"reset")) jsForm.static = 2
			if (jsForm.name != "") jsForm.formID = jsForm.name;
			eventOnStart = getParms(field.slice(2),"onStart") 
		} else if (type == "CHECK") {
			fGen.prototype.addControl(controls,field[1],field.slice(2))
		} else if (type == "DEFAULT") {
			defaults.push(field.slice(1))
		} else if (type == "DICT") {
			if (has(field,"from")) {
				const fnz = getParms(field,"from")
				if(typeof window[fnz] == "function") this.fg_dictionary = window[fnz](getParms(field,fnz))
				console.log(typeof fnz,this.fg_dictionary)					
			}
			else this.fg_dictionary = eval(field[1]);
		} else if (type == "EVENT") {
			name = getParms(field,"on","fg_unknown")
			var eventParms = {field:name,parm:getParms(field,"set")}
			var fnzType = getParmsKey(field,"server|call|submit|alert").toLowerCase()
			switch (fnzType) {
				case "call":
				case "server":
					eventParms[fnzType] = getParms(field,fnzType)
					break
				case "alert":
					eventParms.call = fnzType
					eventParms.parm = getParms(field,fnzType)
					break
				case "submit":
					eventParms.server = "submit"
			}
			fg_setEvent(name,field[1],eventParms)					
		} else if (type == "REQ") {
			for (var j=1;j<field.length; j++) if (field[j] != "") fGen.prototype.addControl(controls,field[j],Array("is","required","required"));
		} else if (type == "GET") {
			aGets.push([field[1],field[2],getParms(field,"every","0")])
		} else {
			if (acceptedTypes[type] == undefined && type != "U") {
				name = "fg_" + i
				field = ["C",name, "Unknown type: "+type,"color","red"]
				widgets[name] = []
				widgets[name].width = 0
				widgets[name].default = ""
				widgets[name].place = ""
			}
			if (okTypes[type] != undefined) lone += okTypes[type];
			if (type != "I" && field[2] == "") field[2] = normalizeLabel(field[1]);	// label
			widgets[name].push(...field);
			var evnt = getParms(field.slice(2),"event")
			if (evnt != "") {
				var f = fGen.prototype.fg_extractTokens(wdg[i],true)
				wdg[wdg.length] = `Event ${evnt} on ${name} ${f.slice(contains(f,evnt) + 1).join(" ")}`
			}
		}
	}
	if (lone > 2 || lone == 0) {
		if (lone > 2) {
			if (widgets.fg_Ok == undefined && (typeOfButton & 1) != 1) {widgets.fg_Ok = ["B","fg_Ok","Ok"];widgets.fg_Ok.place = "bottom"}
			if (widgets.fg_Reset == undefined) {widgets.fg_Reset =["B","fg_Reset","Reset"];widgets.fg_Reset.place = "bottom"}
		}
		if (widgets.fg_Cancel == undefined && jsForm.static != 1) {widgets.fg_Cancel = ["B","fg_Cancel","Cancel"];widgets.fg_Cancel.place = "bottom"}	// no cancel button if the form is static
		typeOfButton |= 2	// standard button(s) exists
	}
	var formID = jsForm.formID;
	if($(formID)) {
		$(formID).parentNode.removeChild($(formID));	// if the form exists
	}
	var frm = styles + "<FORM id='"+formID+"' method='POST'" + ((jsForm.server != "" && jsForm.call == "")?" action='"+jsForm.server+"'":"") + ">";
	frm += "\n<Table class='fg_Table'>";
	if (jsForm.title != "") {	// title **************
		frm += "\n<tr><th class='fg_Title' colspan=3 id='"+jsForm.name+"fg_Title'>"
		frm += this.genImgTag(jsForm.title);
		frm += "</th></tr>";
	}
	var aWidgets = Object.keys(widgets);
	for (let i = 0;i<aWidgets.length;i++) {
		var field = widgets[aWidgets[i]];
		var [type,name,label,...extra] = field;
		if (extra.length == 0) extra = [""]
		const fieldLength = widgets[name].width
		const IDName = jsForm.name+name;
		if (type == "H") {
			if (widgets[name].default == "") widgets[name].default = label
			hiddens[name] = label
			continue
		}
		if (type != "I") label = this.genImgTag(label);
		const tdLabel = "\n<tr><td class='fg_Label'>"+label+"</td><td>";
		if (type == "C") {	// Comment fields
			var style = getParmsKey(extra,"center|right|justify")
			if (style != "") style = "text-align:"+style+";"
			if (fieldLength > 0) style += "width:"+widgets[name].width+"px"
			if (style != "") style = " style='"+style+"'"
			var comment = "<span id='" +IDName + "' class='fg_Comment'></span>"
			if (widgets[name].default == "") widgets[name].default = label
			if (widgets[name].place == "") frm += "\n<tr><td colspan='3' "+style+">" + comment;
			else {widgets[name].placeValue = comment}		// this is an after
			continue;
		}
		if (type == "I") {	// Image field
			var isLabelGraficFile = hasGraphicFile(label)			
			if (widgets[name].default == "") widgets[name].default = isLabelGraficFile ? label : (hasGraphicFile(field[3]) ? field[3] : "")
			var img = "<span></span><img src='' id='" +IDName + "' class='fg_Image'";
			img += ((fieldLength != "") ? " height='" + getParms(extra,"height",150) +"'" : "")+"><span></span>";
			if (widgets[name].place == "") {
				if (isLabelGraficFile || label == "") {
					frm += "\n<tr><td colspan='3'>"+img;
				} else frm += tdLabel+img;
			} else widgets[name].placeValue = img		// this is an after
			continue;
		}
		if (type == "B") {
			field[2] =fGen.prototype.translate(this.fg_dictionary,field[2])
			var btn = createButton(field)
			if (!has(extra,"inline")) {
				if (widgets[name].place == "") {widgets[name].place = "bottom"}
				widgets[name].placeValue = btn
			} else {
				frm +=  "\n<tr><td colspan='3'>" + btn
			}
			continue
		}
		if (widgets[name].place == "") frm += tdLabel;	// is not an afteror below
		if (type == "CKB") {								// Check box *******************
			var ckb = "<input type='checkbox' id='"+IDName+"' name='"+name+"'" + (has(extra,"on") ? " checked " : "") + "/> " 
			+ this.translate(this.fg_dictionary,extra[0]);
			if (widgets[name].default == "") widgets[name].default = "on"
			if (widgets[name].place == "") frm += ckb;
			else {widgets[name].placeValue = ckb}	// this is an after
		} else if (type == "CKL") {						// Check list ******************
			var aItems = this.splitKeyValue(extra[0]);
			hiddens[name] = 0
			var ckb = ""
			aItems.forEach(aItem => {
				widgets[aItem[0]] = Array("CKB",aItem[0],aItem[1]);	// complete widgets
				widgets[aItem[0]].default = "On"
				ckb += "<input type=checkbox "
				+ " id='"+jsForm.name+aItem[0]+"' name='"+aItem[0]+"'/> " 
				+ "<span class=fg_Inline>" + this.genImgTag(aItem[1]) + "</span><br>"
			})
			frm += ckb.substring(-4)
		} else if (type == "CMB" || type == "L") {	// combo and List **************
			loneField = name
			if (type == "CMB") {
				hiddens[name + "_Group"] = ""
				hiddens[name + "_Exposed"] = ""
				var cmb = "<SELECT id='"+IDName + "' name='"+name +"'>"+this.createOptions(IDName,extra[0])+"</SELECT>";
				var parm2 = has(extra,"exposed") ? 1 : (has(extra,"group") ? -1 : 0)
				if (has(extra,"link")) fg_setEvent(name,"change",{call:this.fg_link,field:name,parm:getParms(extra,'link',""),parm2:parm2})
				if (has(extra,"multiple")) widgets[name].multiple = true
			} else {
				var cmb = "<input name='" + name + "' id='" + IDName + "' list='" + IDName + "_List'/>"
				+ "<datalist name='" + name + "' id='" + IDName + "_List'>"+this.createOptions(IDName + "_List",extra[0])+"</datalist>"
				erasables[name] = IDName
			}
			if (widgets[name].place == "") frm += cmb;
			else {widgets[name].placeValue = label+cmb}	// this is an after
		} else if (type == "S") {			// ***************** Slider *********************
				if (field[4] == "") {field[4] = "0";field[5] = "100";field[6] = "1";}// slider range and step
				var min = Number(getParms(extra,"From",0));
				var max = Number(getParms(extra,"To",100));
				var delta = Math.abs(max-min);
				if (min > max) [min,max] = [max,min]	// swap
				var step = getParms(extra,"Step",1/(Math.pow(10,((Math.floor(log10(delta)-2) < 1)?-Math.floor(log10(delta)-2):0))));
				if (widgets[name].default == "") widgets[name].default = min + 0.5 * (max - min)
				frm += "\n<input type=range id='"+IDName + "' name='"+name +"' min='"+min+"' max='"+max + "'"
				if (step != 0) frm += " step='" + step + "'";
				frm += " onChange='$(\"s_\"+this.id).innerHTML = this.value'";
				frm += " style='width:" + fieldLength + "px;vertical-align: middle'/>";
				frm += "<span id='s_" + IDName +"' class='fg_Slider'></span>";			
		} else if (type == "T") {		// Text fields **************
			loneField = name
			widgets[name].disabled = has(extra,"disabled")
			widgets[name].hint = fGen.prototype.translate(this.fg_dictionary,getParms(extra,"hint",""))
			if (fieldLength > llText || has(extra,"rows|row")) {
				txt = "\n<textarea cols=" + Math.min(50,fieldLength) + " rows=" + getParms(extra,"rows|row",Math.ceil(fieldLength / llText)) 
					+ " placeholder='"+widgets[name].hint+"'"
					+ " id='"+IDName + "' name='"+name +"' class='fg_TextArea'" + (widgets[name].disabled ? " disabled class='fg_UType'" : "") + "></textarea>";
			} else {
				var inputType = getParmsKey(extra,"password","text")
				var fileAttrib = ""
				if (has(extra,"file")) {
					inputType = "file"
					jsForm.encoding = "F";
					fileAttrib = (has(extra,"accept")) ? " accept='"+getParms(extra,"accept","")+"' ":"";
					if (has(extra,"capture")) {
						var capture = getParms(extra,"capture")
						fileAttrib += (capture != "" && has([capture],"user|environment")) ? " capture='"+capture+"'" : " capture";
					}
				}
				var numType = getParmsKey(extra,"integer|float|positive")
				if (numType != "") {
					widgets[name].type = numType
					fg_setEvent(name,"keyup",{call:fg_handleInput,field:name})
					if (!has(extra,"width")) widgets[name].width = numberLength[numType]
				}
				var txt = "\n<input type='"+inputType+"' " + idNameSize(field) + fileAttrib + " " + (widgets[name].disabled ? " disabled class='fg_UType'" : "")
					+ ((numType != "") ? " class='fg_Number'" : "") + "/>";
				if (numType == "float") fGen.prototype.addControl(controls,name,Array("is","^[+-]?(?:\\d+|\\d+\\.\\d+)$","Incorrect number"))
				if (numType == "integer") fGen.prototype.addControl(controls,name,Array("is","^[+-]?\\d+$","Incorrect number"))
				if (has(extra,"password")) {
					txt += "<span class=fg_CharButton onClick='alert($(\"" + jsForm.name+name + "\").value)'>&#x1F441;</span>";
				}
			}
			if (widgets[name].place == "") frm += txt;
			else {widgets[name].placeValue = label+txt}	// this is an after
			if (!widgets[name].disabled) erasables[name] = IDName
		} else if (type == "R") {		// *************** Radio buttons *******************
			loneField = name
			var aItems = this.splitKeyValue(extra[0]);
			var rdb = ""
			aItems.forEach(aItem => {
				if (has(extra,"vertical")) rdb += "<br>";	// vertical radio buttons
				rdb += "\n<input type=radio name='"+name+"' id='"+IDName+aItem[0] + "' value='"+ aItem[0] + "'/><span class=fg_Inline>" 
				+ this.genImgTag(aItem[1]) + "</span>";
			})
			frm += ((has(extra,"vertical")) ? rdb.substring(-4) : rdb)			
			frm += "\n<input type=radio name='" + name + "' id='" + IDName + "' value='' CHECKED style='display:none'>";
//			if (events[name] != undefined) {delete events[name];}
		} else if (type == "DATE") {
			loneField = name
			frm += "<input type='date' name='" + name + "' id='" + IDName + "'>";
		}
	}
	for (var n = 0; n < defaults.length;n++) {storeDefaults(defaults[n])}
	if (lone < 3 && lone != 0 && jsForm.static != 1) {		// widget without buttons
		type = widgets[loneField][0]
		if (type == "CMB" || type == "L") {
			fg_setEvent(loneField,"change",{call:fg_handle,parm:loneField})
			if (type == "L") fg_setEvent(loneField,"keydown",["","",fg_handle,loneField])
		} else if (type == "DATE" || has(widgets[loneField].slice(3),"file")) {	// before text
			fg_setEvent(loneField,"change",{call:fg_handle,parm:loneField})
		} else if (type == "T")
		fg_setEvent(loneField,"keydown",{call:fg_handleEnter,parm:loneField})
		else if (type == "R") {
			for (var ck=0;ck<aItems.length;ck++) {
				fg_setEvent(loneField+aItems[ck][0],"change",{call:fg_handle,parm:loneField})
			}
		}
	}
	if (typeOfButton != 0) frm += 	"<tr><td id='" + jsForm.name + "_fg_Bottom' colspan=2 style='text-align:center' class='fg_Buttons'>" 
	$(idDiv).innerHTML = frm+'</Table></FORM>';
	// add buttons after/below, titles, class, ...	*********************
	Object.keys(widgets).forEach(f => {
		var place = widgets[f].place
		const [type,name] = widgets[f]
		if (place == "after" || place == "below") {
			var afterField = widgets[f].placeField
			if (widgets[afterField] == undefined) console.log("field",afterField,"doesn't exists")
			else {
				var after = document.createElement("span");
				after.innerHTML = ((place == "after") ? "" : "<br>") + widgets[f].placeValue
				$(jsForm.name+afterField).after(after)
			}
		} else if (place == "bottom") {
				$(jsForm.name+"_fg_Bottom").innerHTML += widgets[f].placeValue;			
		}
		if (widgets[f].class != undefined) $(jsForm.name+name).setAttribute("class", widgets[f].class)
		if (widgets[f].title != undefined) $(jsForm.name+name).setAttribute("title", widgets[f].title)
		if (widgets[f].multiple != undefined) {
			$(jsForm.name+name).multiple = true
			$(jsForm.name+name).setAttribute('name',name+"[]")
		}
	})
	Object.keys(erasables).forEach(f => { // for after eraser and add event
		var span = document.createElement("span")
		span.setAttribute("class","fg_Erase");
		span.innerHTML = "&#x2718;"
		$(erasables[f]).after(span)
		span.addEventListener("click",() => {fGen.prototype.setDefaults(formID,f)})
	})
	//	 add hidden	****************************
	Object.keys(hiddens).forEach(f => {
		var hidden = $(formID).appendChild(document.createElement("input"))
		hidden.setAttribute("type","hidden");
		hidden.setAttribute("name",f);
		hidden.setAttribute("id",jsForm.name+f);
		hidden.setAttribute("value",hiddens[f]);
	})
	// add controls	****************************
	for (field in controls) {
		if (field != "*") {		// general check
			if (widgets[field] == undefined) {
				alert ("Control " + field + " not exists")
				delete controls[field];
			}
		}
	}
	$(formID).fg_check = check
	$(formID).fg_createOptions = this.createOptions.bind(this)
	$(formID).fg_formFields = formFields.bind(this)
	$(formID).fg_jsForm = jsForm
	$(formID).fg_setValue = setValue
	$(formID).fg_widgets = widgets
// add events ***************************************************
	Object.keys(events).forEach(f => {
		var eField = jsForm.name+f
		Object.keys(events[f]).forEach(evnt => {
			if ($(eField) == null) {
				console.log(eField + ": event field not present")
			} else {
				var {server:fnz = "",call:jsFnz = "",field:fieldID = "",parm,parm2} = events[f][evnt]
				if (fnz != "") {	// server function (URI)
					if ($(fieldID) == null) {
						if ($(jsForm.name+fieldID) == null) console.log(fieldID + ": field ID not present")
						else fieldID = jsForm.name+fieldID
					}
					if (fnz == "submit") {
						if (evnt == "enter") $(eField).addEventListener("keydown",fg_handleEnter.bind(event,$(formID),fieldID,parm));
						else $(eField).addEventListener(evnt,fg_handle.bind(event,$(formID),f));
					} else {
						console.log(f,fieldID,jsFnz,parm,parm2)
						$(eField).addEventListener(evnt,(fnz,formID,fieldID,jsFnz,parm,parm2) => fGen.prototype.ajax(fnz,formID,fieldID,jsFnz,parm,parm2));
					}
				} else {	// only javascript function				
					if (typeof jsFnz == "function") {	// the case of internal function like fg_handle
						$(eField).addEventListener(evnt,jsFnz.bind(event,$(formID),fieldID,parm,parm2));
					} else if (window[jsFnz] != undefined || jsFnz.substr(0,8) == "formGen.") {
						if (jsFnz == "alert") $(eField).addEventListener(evnt,function(alrt){alert(alrt)}.bind(event,fGen.prototype.translate(this.fg_dictionary,parm)));
						else $(eField).addEventListener(evnt,eval(jsFnz).bind(event,eField,parm));						
					} else console.log(jsFnz, "isn't a function")
				}
			}
		})
	})
/********************  handle GET pseudo type ********************/
	var ajaxCount = [0];
	for (var i=0;i<aGets.length;i++) {
		var [name, url,timeout] = aGets[i];	// GET,[* | name],URI[,timeout]
		ajaxCount[0]++;
		fGen.prototype.ajax(url,"",jsForm.name+name,saveDefault,name,ajaxCount)
		var timeout = parseInt(timeout,10);
		if (timeout > 99) {
			intervalHandlers.push(setInterval(fGen.prototype.ajax.bind(),timeout,url,$(formID),jsForm.name+name));
		}
	}
	var totalWait = aGets.length * 2000
	const waitx = (delayTime) => new Promise((resolve) => setTimeout(resolve, delayTime));
	async function waitAjax(totalWait) {
		for(let t = totalWait;t > 0;t-=500) {
			await waitx(500);
			if (ajaxCount[0] == 0) {break;}
		}
		if (ajaxCount[0] > 0) alert("Ajax timeout after "+totalWait + "ms");
		fGen.prototype.setDefaults(formID);	// set defaults
	}
	waitAjax(totalWait)
	if (eventOnStart != "") window[eventOnStart]($(formID))
	return
};
}
fGen.prototype.fg_extractTokens = function(s, delimiter) {
	if (delimiter == undefined) var delimiter = false
	const reSplitTokens = /("[^"]*")|('[^']*')|(\S+)/g	// thank to Taky
	var matchs = [...(s).matchAll(reSplitTokens)]		// ... copies array
	a = []
	matchs.forEach((match) => {
		if (!delimiter && match[3] == undefined) {	// if match[3] there aren't delimiters
			match[0] = match[0].substr(1,match[0].length -2)
	    }
	    a[a.length] = match[0]
	});
    return a
}
fGen.prototype.ajax = function(url,frm,handler,parm1,parm2,ajaxCount) {
	var data = (typeof(frm) == "string")? frm :new FormData(frm);
	var ajx = new XMLHttpRequest();
	var fnz = function (count) {
		if (ajx.readyState == 4) {
			if (ajx.status == 200) {
				if (count != undefined) count[0]--
				var rsp = ajx.responseText
				if(typeof handler == "function") handler(rsp,frm,parm1,parm2)
				if ($(handler) != undefined) {
					switch ($(handler).nodeName) {
						case "IMG":
							fGen.prototype.showImage(handler,rsp)
							break;
						case "INPUT":
						case "TEXTAREA":
							if ($(handler).list != undefined) {	// is list type
								if (rsp.split(/,\s*/).length == 1) $(handler).value = rsp;
								else $($(handler).form.id).createOptions(handler,rsp);
							} else $(handler).value = rsp;
							break;
						case "SELECT":
							if (rsp.split(/,\s*/).length == 1) $(handler).value = rsp;
							else $(handler).form.fg_createOptions(handler,rsp);
							break;
						default:
							$(handler).innerHTML = rsp;
					}
				}
				if (typeof(parm1) == "function") parm1(rsp,handler,parm2)
			} else alert("Error: " + ajx.status + ": " + ajx.statusText);
		}
	}
	ajx.onreadystatechange = fnz.bind(event,ajaxCount)
	ajx.open("POST", url, true)
	if (typeof data != "object") {ajx.setRequestHeader("Content-type", "application/x-www-form-urlencoded")}
	ajx.send(data);
}
fGen.prototype.isGraphicFile = f => /.+(\.png|\.gif|\.jpeg|\.jpg|\.gif|\.ico)$/i.test(f)
fGen.prototype.showData = function(data) {
	var r = "<table class='fg_Table'>";
	Object.keys(data).sort().forEach(key => {r += "<tr><td>"+key+"<td>"+data[key]});
	return r+"</table>";
}
fGen.prototype.showImage = function(img,rsp) {
	var a = rsp.split(/\t|:/);
	if (fGen.prototype.isGraphicFile(a[0])) {
		$(img).src = a[0];
		if (a.length > 1 && $(img).nextSibling != null) $(img).nextSibling.innerHTML = a[1]
	} else {
		if($(img).previousSibling != null) $(img).previousSibling.innerHTML = a[0]
		if (a.length > 1) $(img).src = a[1];
	}
}
fGen.prototype.setDefaults = function(frm,widget) {	// form and possibly widget if only one field to set
	var widgets = $(frm).fg_widgets;
	for (var i in widgets) {
		var [,name] = widgets[i]
		if (widget == undefined || widget == name) $(frm).fg_setValue(name,widgets[i].default)
	}
	if (widget == undefined) $(frm).fg_formFields($(frm));	// save initial form values
}
fGen.prototype.addControl = function(controls,name,control) {
	if (controls[name] == undefined) controls[name] = Array()
	controls[name].push(control);
}
fGen.prototype.translate = (obj,w) => {
	w = w.replace(/\\x[0-9A-F]{1,5}/gi,s => String.fromCharCode(parseInt("0"+s.substring(1))));
	return (obj == undefined || obj[w] == undefined) ? w : obj[w].replace("\n","<br>")
}
fGen.prototype.timeStamp = d => d.toISOString().slice(0,19).replace("T"," ")