//*****************************************************************************
// Modified source of Mike Hall by El Condor Mars 2021
// Mike Hall site See http://www.brainjar.com.
// free to use but no warranties
//*****************************************************************************
// Global object to hold drag information.
var dragObj = new Object();
dragObj.zIndex = 10000;
function dragStart(event, id) {
	var x, y;
	dragObj.elNode = document.getElementById(id);
	dragObj.cursorStartX = -1;
	dragObj.cursorStartY = -1;
	dragObj.elStartLeft  = parseInt(dragObj.elNode.style.left, 10);
	dragObj.elStartTop   = parseInt(dragObj.elNode.style.top,  10);
	if (isNaN(dragObj.elStartLeft)) dragObj.elStartLeft = 0;
	if (isNaN(dragObj.elStartTop))  dragObj.elStartTop  = 0;
	// Update element's z-index.
	dragObj.elNode.style.zIndex = ++dragObj.zIndex;
	// Capture mousemove and mouseup events on the page.
    document.addEventListener("mousemove", dragGo,   true);
    document.addEventListener("mouseup",   dragStop, true);
}
function dragGo(event) {
	var x, y;
	// Get cursor position with respect to the page.
	x = event.clientX + window.scrollX;
	y = event.clientY + window.scrollY;
	if (dragObj.cursorStartX == -1) {
		dragObj.cursorStartX = x;
		dragObj.cursorStartY = y;
		return;
	}
	// Move drag element by the same amount the cursor has moved.
	dragObj.elNode.style.left = (dragObj.elStartLeft + x - dragObj.cursorStartX) + "px";
	dragObj.elNode.style.top  = (dragObj.elStartTop  + y - dragObj.cursorStartY) + "px";
	event.preventDefault();
}
function dragStop(event) {
  // Stop capturing mousemove and mouseup events.
	document.removeEventListener("mousemove", dragGo,   true);
	document.removeEventListener("mouseup",   dragStop, true);
}